Bug 1433749 - Review Request: vrms-rpm - report of installed nonfree software
Summary: Review Request: vrms-rpm - report of installed nonfree software
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Neal Gompa
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-03-19 19:21 UTC by Artur Iwicki
Modified: 2017-06-24 02:18 UTC (History)
2 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2017-06-13 13:35:04 UTC
ngompa13: fedora-review+


Attachments (Terms of Use)

Description Artur Iwicki 2017-03-19 19:21:18 UTC
Spec URL: https://svgames.pl/fedora/vrms-rpm.spec
SRPM URL: https://svgames.pl/fedora/vrms-rpm-1.0-2.src.rpm
Description: This program analyses the list of currently installed RPM packages and reports found nonfree packages to stdout.
Fedora Account System Username: suve

The build was successfully tested in koji:
https://koji.fedoraproject.org/koji/taskinfo?taskID=18476914

The build was also done in copr and worked successfully for all platforms apart from epel-5-i386, epel-5-x86_64 and fedora-26-ppc64le. (Rather confusing, seeing how this is essentially a bash script + manpage, no compilation needed.)
https://copr.fedorainfracloud.org/coprs/suve/vrms-rpm/

I am the upstream developer of this software. 

As this is my first submitted package, I am looking for reviews and sponsorship.

Comment 1 Michael Schwendt 2017-03-22 20:12:02 UTC
Small as it may be, but there are still some relevant things in the guidelines:


> Name:          vrms-rpm
>
> %description
> vrms-rpm reports nonfree packages installed on the system.

Explaining in the package description what "vrms" means would be good. Is it based one "Virtual Richard M. Stallman"?


> Release:       2  

https://fedoraproject.org/wiki/Packaging:Versioning#Simple_versioning


> License:       GPLv3

https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text


> # Archive generated from git repository
> # No modifications made
> Source0:       %{name}-%{version}.zip

https://fedoraproject.org/wiki/Packaging:SourceURL


> install -m 755 %{_builddir}/%{name}-%{version}/vrms-rpm.sh %{buildroot}%{_bindir}/vrms-rpm
> install -m 644 %{_builddir}/%{name}-%{version}/vrms-rpm.man %{buildroot}%{_mandir}/man1/vrms-rpm.1

Examine the rpmbuild build output and notice that at the start of every main spec file section, such as %prep, %build, %install, %clean, rpmbuild enters the builddir automatically. If it doesn't, adjust the %setup macro in the %prep section appropriately. It is not necessary to specify the full source path like you've done it here.


> %files
> %{_mandir}/man1/vrms-rpm.1.gz

The more flexible notation for manual pages is 

  %{_mandir}/man1/vrms-rpm.1*

to cover any compressor and even disabled compression.

Comment 2 Artur Iwicki 2017-03-22 22:09:30 UTC
(In reply to Michael Schwendt from comment #1)
> Explaining in the package description what "vrms" means would be good. Is it
> based one "Virtual Richard M. Stallman"?
It is a clone of said software. Would something like 'vrms-rpm ("virtual Richard M. Stallman") reports...' suffice?

As for the release number: This is the spec file I used for the copr build; I had to re-package that one, hence the greater release number. I have now bumped it to 3 after making further changes to the spec file. (Although I've noticed that I've missed the %{dist} tag requirement, thank you for that.)

Regarding the licence: I have added the licence file in the %files section, as instructed on the wiki page.

Regarding the Source0 URL: I added a tag in the git repo and switched to using a generated tarball for the source.
 
Thank you for your notes regarding the builddir and the manpage notation. I have made appropriate changes to the spec file.

Updated links to the spec file and the SRPM:
https://svgames.pl/fedora/vrms-rpm-1.0-3.spec
https://svgames.pl/fedora/vrms-rpm-1.0-3.src.rpm

Once again, a link to the koji build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=18528835

Comment 4 Dominik 'Rathann' Mierzejewski 2017-04-14 22:15:09 UTC
You should use install with -p option (in addition to -m) for installing files into their destination location in %install. Otherwise they get package-build-time timestamps.

https://fedoraproject.org/wiki/Packaging:Guidelines#Timestamps

Comment 6 Neal Gompa 2017-05-17 12:46:48 UTC
I'll take this review formally.

I've also seen you do at least one informal review[1], showing that you understand the guidelines, so I'll be happy to sponsor you as well (since no one else has said they'll sponsor you).

[1]: https://bugzilla.redhat.com/1444518

Comment 7 Artur Iwicki 2017-05-20 09:35:12 UTC
I ran fedora-review on the package and a minor issue with the dist-tag came up, so I made a new release.

spec: https://svgames.pl/fedora/vrms-rpm-1.1-3.spec
srpm: https://svgames.pl/fedora/vrms-rpm-1.1-3.src.rpm

koji: https://koji.fedoraproject.org/koji/taskinfo?taskID=19641736
copr: https://copr.fedorainfracloud.org/coprs/suve/vrms-rpm/build/554436/


Thank you for sponsorship, Neal. I'm still fairly new to RPM packaging, so I prefer to be cautious about reviewing (nothing worse than giving out bad advice). Still, I have done another two reviews. [1] [2]

https://bugzilla.redhat.com/1451298
https://bugzilla.redhat.com/1450572

Comment 8 Artur Iwicki 2017-06-01 16:53:18 UTC
I have made a new upstream release. This one required some more significant changes to the spec file, as localised files and a Makefile were introduced.

spec: https://svgames.pl/fedora/vrms-rpm-1.2-1.spec
srpm: https://svgames.pl/fedora/vrms-rpm-1.2-1.src.rpm

koji: https://koji.fedoraproject.org/koji/taskinfo?taskID=19804618
copr: https://copr.fedorainfracloud.org/coprs/suve/vrms-rpm/build/560464/

Ignore the lone failed chroot for copr; the logs say it failed to install bash during the mock-build.

Comment 9 Neal Gompa 2017-06-01 17:32:55 UTC
> URL:           https://github.com/%{githubowner}/%{name}/
> Source0:       %{url}archive/%{gittag0}.tar.gz#/%{name}-%{gittag0}.tar.gz

Please adjust the URL structure to be properly segmented. For example:

URL:           https://github.com/%{githubowner}/%{name}
Source0:       %{url}/archive/%{gittag0}/%{name}-%{gittag0}.tar.gz

> make build PREFIX=/usr %{?_smp_mflags}

Please use %{_prefix} for PREFIX= value. Also, as an alternative, you can simplify this with "%make_build PREFIX=%{_prefix}"

> make install PREFIX=%{buildroot}/usr %{?_smp_mflags}

Use %{buildroot}%{_prefix} here. Also, consider supporting DESTDIR so that the standard %make_install macro works.

Comment 10 Neal Gompa 2017-06-01 17:37:02 UTC
> %{find_lang} %{name} --with-man 

Please use "%find_lang" instead of "%{find_lang}", as it helps identify it as a parameterized macro.

Comment 11 Artur Iwicki 2017-06-03 07:23:00 UTC
Adjusted the URL and the %find_lang usage as asked.

I've actually tried using %{prefix}, but that didn't work. Didn't think about trying the underscored version... Fixed. Did not use the %make_build macro, as that results in a "make" call, whereas the project requires "make build" (default target just prints some help text).

spec: https://svgames.pl/fedora/vrms-rpm-1.2-2.spec
srpm: https://svgames.pl/fedora/vrms-rpm-1.2-2.src.rpm

koji: https://koji.fedoraproject.org/koji/taskinfo?taskID=19816977
copr: https://copr.fedorainfracloud.org/coprs/suve/vrms-rpm/build/561094/

Comment 12 Neal Gompa 2017-06-03 10:11:53 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- Spec file name must match the spec package %{name}, in the format
  %{name}.spec.
  Note: vrms-rpm-1.2-2.spec should be vrms-rpm.spec
  See:
  http://fedoraproject.org/wiki/Packaging/NamingGuidelines#Spec_file_name


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "CDDL CeCILL-B CC by", "GPL (v3)", "*No copyright* GPL (v3)",
     "Unknown or generated". 6 files have unknown license. Detailed output
     of licensecheck in /home/makerpm/1433749-vrms-
     rpm-1.2-2/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: vrms-rpm-1.2-2.fc27.noarch.rpm
          vrms-rpm-1.2-2.fc27.src.rpm
vrms-rpm.noarch: W: spelling-error %description -l en_US Stallman -> Stall man, Stall-man, Stableman
vrms-rpm.src: W: spelling-error %description -l en_US Stallman -> Stall man, Stall-man, Stableman
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
vrms-rpm.noarch: W: spelling-error %description -l en_US Stallman -> Stall man, Stall-man, Stableman
1 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
vrms-rpm (rpmlib, GLIBC filtered):
    /bin/bash
    bash
    gettext
    grep



Provides
--------
vrms-rpm:
    vrms-rpm



Source checksums
----------------
https://github.com/suve/vrms-rpm/archive/release-1.2.tar.gz#/vrms-rpm-release-1.2.tar.gz :
  CHECKSUM(SHA256) this package     : 9ae6a24cc70366683fee33ce6dfdd4abc5663cf1ddb419cf73924fe129437185
  CHECKSUM(SHA256) upstream package : 9ae6a24cc70366683fee33ce6dfdd4abc5663cf1ddb419cf73924fe129437185


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/bin/fedora-review -b 1433749 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 13 Neal Gompa 2017-06-03 10:13:15 UTC
Make sure that the spec file is vrms-rpm.spec on import into Dist-Git. Otherwise, looks good to me.

PACKAGE APPROVED.

Comment 14 Neal Gompa 2017-06-03 10:15:10 UTC
I have sponsored you into the packager group. Welcome to the Fedora Packagers group!

Comment 15 Gwyn Ciesla 2017-06-05 12:29:51 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/vrms-rpm

Comment 16 Fedora Update System 2017-06-05 20:28:00 UTC
vrms-rpm-1.2-2.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-7867abc53f

Comment 17 Fedora Update System 2017-06-05 20:28:55 UTC
vrms-rpm-1.2-2.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-b845d4ecb4

Comment 18 Fedora Update System 2017-06-05 20:29:36 UTC
vrms-rpm-1.2-2.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-78b01e2393

Comment 19 Fedora Update System 2017-06-06 19:04:46 UTC
vrms-rpm-1.2-2.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-78b01e2393

Comment 20 Fedora Update System 2017-06-06 19:38:37 UTC
vrms-rpm-1.2-2.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-98ccd46108

Comment 21 Fedora Update System 2017-06-06 19:39:09 UTC
vrms-rpm-1.2-2.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-bbbae25d00

Comment 22 Fedora Update System 2017-06-07 07:33:35 UTC
vrms-rpm-1.2-2.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-b845d4ecb4

Comment 23 Fedora Update System 2017-06-07 07:33:59 UTC
vrms-rpm-1.2-2.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-7867abc53f

Comment 24 Fedora Update System 2017-06-07 16:50:30 UTC
vrms-rpm-1.2-2.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-98ccd46108

Comment 25 Fedora Update System 2017-06-07 16:54:42 UTC
vrms-rpm-1.2-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-bbbae25d00

Comment 26 Fedora Update System 2017-06-13 13:35:04 UTC
vrms-rpm-1.2-2.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Comment 27 Fedora Update System 2017-06-16 17:49:32 UTC
vrms-rpm-1.2-2.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 28 Fedora Update System 2017-06-16 18:51:32 UTC
vrms-rpm-1.2-2.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 29 Fedora Update System 2017-06-24 02:17:22 UTC
vrms-rpm-1.2-2.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Comment 30 Fedora Update System 2017-06-24 02:18:36 UTC
vrms-rpm-1.2-2.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.